#if !defined(AFX_FilePage_H__INCLUDED_)
#define AFX_FilePage_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FilePage.h : header file
//

#include "CfgPropSheet.h"
#include "afxwin.h"
#include "label.h"

/////////////////////////////////////////////////////////////////////////////
// CFilePage dialog

class CFilePage : public CCfgPropPage
{
	DECLARE_DYNCREATE(CFilePage)

// Construction
public:
	CFilePage();
	~CFilePage();

// Dialog Data
	//{{AFX_DATA(CFilePage)
	//enum { IDD = IDD_FILE_PAGE };
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFilePage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CFilePage)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	CToolTipCtrl m_ToolTip;								// Tooltip control

public:
	//CStatic m_FilePageLabel;
	CLabel m_FilePageLabel;
	//CStatic m_FileAdvancedLabel;
	CLabel m_FileAdvancedLabel;
	//CStatic m_FileStandardLabel;
	CLabel m_FileStandardLabel;
	virtual BOOL OnSetActive();
	virtual BOOL OnInitDialog();
	CString m_strConfigIn;
	CString m_strConfigOut;

	afx_msg void OnBnClickedButtonReadConfig();
	void ReadConfigFromAmptek_NP(CString strFilename, CString strKeyName);
	void ReadConfig();

	void InitControls();
	void InitDlgItem(HWND hDlg, DP5_CONFIGURATION cfg);
	void CFilePage::CboUpdate(int nID_dci);

	// Get Amptek Detector Configuration (New Protocol{FW6+}) Section Name
	CString GetAmptekDC_NP_Section();
	// -------------------------------------------------------------------

    afx_msg void OnCbnSelchangeReaddetectorconfigcombo();
	CComboBox m_ReadDetectorConfigCombo;
	void ReadAmptekDetectorConfigNames();

	afx_msg void OnCbnSelchangeOptComboResc();
	//afx_msg void OnBnClickedButtonFindCommand();	// find cfg cmd controls on another page
	afx_msg void OnBnClickedButtonSaveConfig();
	CString SaveConfigString();
	CString GetCmdKeyData(CString strCmd, CString strCfgData);
	afx_msg void OnBnClickedButtonEditConfigFromHw();
	afx_msg void OnBnClickedButtonSendToHardware();

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	BOOL isCEditBox(int nID);
	BOOL isCComboBox(int nID);

	afx_msg void OnTimer(UINT nIDEvent);
	// AutoReadHwConfig 100ms Timer
	UINT_PTR m_nTmrConfigId;		// return SetTimer Return Value (0=false,TimerID if OK)			
	UINT_PTR m_nTmrConfigEventId;	// Timer Event Identifier
	UINT m_nTmrConfigElapse;		// Timeout value in milliseconds

	virtual BOOL OnApply();
	virtual void OnCancel();
	BOOL isClosing;

	void EnableControls(BOOL bEnable);

	afx_msg void OnBnClickedButtonSendToHardwareNoEdit();
	afx_msg void OnBnClickedRadioDppDeviceType1();
	afx_msg void OnBnClickedRadioDppDeviceType2();
	afx_msg void OnBnClickedRadioDppDeviceType3();
	afx_msg void OnBnClickedRadioDppDeviceType4();
	afx_msg void OnBnClickedRadioDppDeviceType5();
	afx_msg void OnBnClickedRadioDppDeviceType6();
	void SetDppDeviceType(int DeviceType);
	void SelectRadioDppDeviceType(int DeviceType);
	void EnableDeviceSelection(BOOL bEnable);

	afx_msg void OnCbnSelendokReaddetectorconfigcombo();
	afx_msg void OnBnClickedCheckPc5Present();
	void SetCheckPc5Present();

	// DP5 Rev Dx (Rev D0 and above) extended gain range control
	// enables configuration selections when no dp5 device is attached
	afx_msg void OnBnClickedCheckDP5DxGains();
	void SetCheckDP5DxGains();

	afx_msg void OnStnClickedStaticReadConfig();
	afx_msg void OnStnClickedStaticSaveConfig();
	afx_msg void OnBnClickedButtonSendCommand();

	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);

	afx_msg void OnBnClickedButtonSendCommand2();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FilePage_H__INCLUDED_)
